/////////////////////ACDFSM by Redphoenix///////////////////////////////////////////////
//////main shader using 3 depth samplers with different arc values
///////////////////////////////////////////////////////////////////////////////////////////////////////////
Texture mtlSkin1;
Texture mtlSkin2;
Texture entSkin1;

float3 vecSunPos;
float4x4 matMtl; 	// Texture projection matrix
float4x4 matEffect1; 	

const float4x4 matWorld;	// World matrix.
const float4x4 matViewProj;	// World matrix.
const float4 vecSunDir;	// Sun direction vector.
float4 vecSkill1; //x = depth_bias, y = brightness 
float4 vecViewPos;

sampler2D main_map = sampler_state { Texture = <entSkin1>;
   AddressU  = wrap;
AddressV  = wrap;


 };
sampler2D shadow_map = sampler_state { Texture = <mtlSkin1>;
   AddressU  = clamp;
AddressV  = clamp;


 };
sampler2D shadow2_map = sampler_state { Texture = <mtlSkin2>;
   AddressU  = clamp;
AddressV  = clamp;


 };
// Vertex Shader
void depthVS (in float4 inPos: POSITION,
		in float4 inTex: TEXCOORD0,
		in float3 inNormal: NORMAL,
		out float4 outPos: POSITION,
		out float3 outTex: TEXCOORD0,
		out float3 outNormal: TEXCOORD1,
		out float4 outDepth: TEXCOORD2,
		out float4 outDepth2: TEXCOORD3)
{
// Transform the vertex from object space to clip space:
	outPos = mul(mul(inPos,matWorld),matViewProj);
// Transform the normal from object space to world space:
	outNormal = normalize(mul(inNormal,matWorld));
// Pass the texture coordinate to the pixel shader:
	outTex.xy = inTex.xy;
	outDepth = mul(mul(inPos,matWorld),matMtl);
	outDepth2 = mul(mul(inPos,matWorld),matEffect1);
	float3 WorldPos  = mul(inPos, matWorld).xyz;
	float  WorldDist = distance(WorldPos.xyz, vecViewPos.xyz);
	outTex.z = saturate(pow(WorldDist/vecSkill1.z,2)-0.5);
   
}

float4 mainPS(float3 tex : TEXCOORD0, float3 inNormal : TEXCOORD1, float4 shadowCrd : TEXCOORD2, float4 shadowCrd2 : TEXCOORD3) : COLOR
{
	float d;// = shadowCrd.z-vecSkill1.x;
   
   //shadowCrd.xy /= shadowCrd.z;	
   float alpha = tex2D(main_map,tex.xy).a;
   shadowCrd.xy /= shadowCrd.w;	
   shadowCrd2.xy /= shadowCrd.w;	
	float4 m;
	 if(shadowCrd2.x < 1.0 && shadowCrd2.x > 0 && shadowCrd2.y < 1.0 && shadowCrd2.y > 0) { m = tex2D(shadow2_map,shadowCrd2); d = shadowCrd.z-vecSkill1.x/2; }
	   else { if(shadowCrd.x < 1.0 && shadowCrd.x > 0 && shadowCrd.y < 1.0 && shadowCrd.y > 0) { m = tex2D(shadow_map,shadowCrd); d = shadowCrd.z-vecSkill1.x; }
                else { m = 100000.0; d = shadowCrd.z-vecSkill1.x*4; }
      }
	
	float fDiffuse = 0.1+saturate(dot(-vecSunDir, normalize(inNormal)));
	
	float max_d = m.w + 0.000001;
	float min_d = m.x;
	float t = saturate((d - min_d) / (max_d - min_d));
	float shadow = 1.0-(3*t*pow(1-t,2)*m.y + 3*t*t*(1-t)*m.z +t*t*t);
	shadow = shadow*fDiffuse+vecSkill1.y+tex.z;
   return float4(shadow,shadow,shadow,alpha);
   
}


// Technique
technique ShadowMap
{
	pass Pass0
	{
		ZWriteEnable = True;
		AlphaBlendEnable = True;		
		CullMode = CCW;		
		//Lighting = False;
		//AlphaTestEnable = True;
		//AlphaRef = 200;
		VertexShader = compile vs_2_0 depthVS();
		PixelShader = compile ps_2_a mainPS();
	}
}