/////////////////////////////////////Approximate Cumulative Distribution Function Shadowmapping by Holger Grn//////////////////////////////
/////////////////////////////////////Implementation for 3D-Gamestudio A7 by Martin Coumont (redphoenix)/////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
credits: Nils Daumann (Slin)

These codes are free for use in commercial or noncommercial projects, as long as they are not sold as they are. credits would be appreciated but aren't need. 

*/
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////header///////////////////////////////////////////////////////////

void Light_mat_event2();

MATERIAL* depth_mat = {
	effect = "depth.fx";
	flags = AUTORELOAD;

}
MATERIAL* combi_mat = {
	effect = "acdfsm_combinescene.fx";
	flags = AUTORELOAD;
	
}

VIEW* combi_view;

BMAP* depth5_a;
BMAP* depth6_a;
BMAP* shadow5;
BMAP* shadow6;
BMAP* shadow7;

#ifndef FLAG_DEFS
#define FLAG_DEFS
#define SUNLIGHT_S (1<<0)
#define POINTLIGHT_P (1<<1)
#define SPOTLIGHT_SP (1<<2)
#define DEPTHBLUR (1<<3)
#define BLUR (1<<4)
#define ROTATE_S (1<<5)
#define MOVE_S (1<<6)
#define ACTIV (1<<7)
#endif

typedef struct SHADOW_STRUCT {
   ENTITY* light;
   var res, range, fade, arc, soften, depth_bias, depth_blur, blur, brightness;
   long flags;
   var views, change;
   var id;
} SHADOW_STRUCT;

SHADOW_STRUCT* sun_shadow = {
	light = NULL;
	res = 512;
	range = 15000;
	fade = 6000;
	arc = 20;
	depth_bias = 80;
	soften = 120;
	depth_blur = 40;
	blur = 60;
	brightness = 80;
	views = 3;
	change = 0;
	flags = SUNLIGHT_S | DEPTHBLUR | MOVE_S | ROTATE_S | ACTIV;
}
float lmatrix1[16];
float lmatrix2[16];
float lmatrix3[16];

SHADOW_STRUCT* shadowlights[100];
SHADOW_STRUCT* temp_shadow;
var num_shadowlights = 0; 
var shadow_brightness = 50;

/////////////////////////////////////////////////shadow initialisation//////////////////////////////////////////////////////////////


function do_shadowmapping(SHADOW_STRUCT* my_shadow) {
	my_shadow.change = 0; if(!is(my_shadow,ACTIV)) return;
	var save_depth; save_depth = my_shadow.views;
	var save_blur1; save_blur1 = is(my_shadow,DEPTHBLUR);
	var save_blur2; save_blur2 = is(my_shadow,BLUR);	
	proc_mode = PROC_LATE;
	MATERIAL* ACDFSM_mat; ACDFSM_mat = mtl_create();
	MATERIAL* depth_mod_mat; depth_mod_mat = mtl_create();	
	VIEW* depth_view = view_create(-1);
	depth_view.size_x = my_shadow.res;
	depth_view.size_y = my_shadow.res;
	depth_view.skill_x = 1;	
	depth_view.skill_y = ACDFSM_mat;
	set(depth_view,UNTOUCHABLE | NOPARTICLE);
	VIEW* depth_mod_view = view_create(-1);
	depth_mod_view.material = depth_mod_mat;
	set(depth_mod_view,PROCESS_TARGET | UNTOUCHABLE);
	depth_mod_view.size_x = my_shadow.res;
	depth_mod_view.size_y = my_shadow.res;	
	depth_view.material = depth_mat;
	BMAP* depth_map_rt = bmap_createblack(my_shadow.res,my_shadow.res,14);
	bmap_to_format(depth_map_rt,14);
	BMAP* depth_map_rt2 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	bmap_to_format(depth_map_rt2,14444);
	set(depth_view,SHOW);
	depth_view.bmap = depth_map_rt;	
	depth_view.stage = depth_mod_view;
	depth_mod_view.bmap = depth_map_rt2;		
	VIEW* blur1;BMAP* depth_map_rtb1;
   MATERIAL* blur1_mat;
	if(is(my_shadow,DEPTHBLUR)) {
	  blur1_mat = mtl_create();
	  blur1 = view_create(-1);
	  set(blur1,PROCESS_TARGET | UNTOUCHABLE);
	  blur1.material = blur1_mat;
	  depth_mod_view.stage = blur1;	
	  depth_map_rtb1 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	  bmap_to_format(depth_map_rtb1,14444);
	  blur1.bmap = depth_map_rtb1;
	  ACDFSM_mat.skin1 = depth_map_rtb1;
	} 
	else ACDFSM_mat.skin1 = depth_map_rt2;
	VIEW* depth2_view;VIEW* depth2_mod_view;BMAP* depth_map_rtd2;BMAP* depth_map_rt2d2;VIEW* blur1d2;BMAP* depth_map_rtb1d2;
	VIEW* depth3_view;VIEW* depth3_mod_view;BMAP* depth_map_rtd3;BMAP* depth_map_rt2d3;VIEW* blur1d3;BMAP* depth_map_rtb1d3;
	VIEW* depth4_view;VIEW* depth4_mod_view;BMAP* depth_map_rtd4;BMAP* depth_map_rt2d4;VIEW* blur1d4;BMAP* depth_map_rtb1d4;	
	if(my_shadow.views >= 2) {	
	  depth2_view = view_create(-1);
	  depth2_view.size_x = my_shadow.res;
	  depth2_view.size_y = my_shadow.res;
	  depth2_view.skill_x = 2;		  
	  set(depth2_view,UNTOUCHABLE | NOPARTICLE);	
	  depth2_mod_view = view_create(-1);
	  depth2_mod_view.material = depth_mod_mat;
	  set(depth2_mod_view,PROCESS_TARGET | UNTOUCHABLE);
	  depth2_mod_view.size_x = my_shadow.res;
	  depth2_mod_view.size_y = my_shadow.res;
	  depth2_view.material = depth_mat;
	  depth_map_rtd2 = bmap_createblack(my_shadow.res,my_shadow.res,14);
	  bmap_to_format(depth_map_rtd2,14);
	  depth_map_rt2d2 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	  bmap_to_format(depth_map_rt2d2,14444);
	  set(depth2_view,SHOW);
	  depth2_view.bmap = depth_map_rtd2;	
	  depth2_view.stage = depth2_mod_view;
	  depth2_mod_view.bmap = depth_map_rt2d2;
	  if(is(my_shadow,DEPTHBLUR)) {
	    blur1d2 = view_create(-1);
	    set(blur1d2,PROCESS_TARGET | UNTOUCHABLE);
	    blur1d2.material = blur1_mat;	    
	    depth2_mod_view.stage = blur1d2;	  
	    depth_map_rtb1d2 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	    bmap_to_format(depth_map_rtb1d2,14444);
	    blur1d2.bmap = depth_map_rtb1d2;
	    ACDFSM_mat.skin2 = depth_map_rtb1d2;
     }
	  else ACDFSM_mat.skin2 = depth_map_rt2d2;    
   }
	if(my_shadow.views >= 3) {   		
	  depth3_view = view_create(-1);
	  depth3_view.size_x = my_shadow.res;
	  depth3_view.size_y = my_shadow.res;
	  depth3_view.skill_x = 3;		  
	  set(depth3_view,UNTOUCHABLE | NOPARTICLE);	
	  depth3_mod_view = view_create(-1);
	  depth3_mod_view.material = depth_mod_mat;
	  set(depth3_mod_view,PROCESS_TARGET | UNTOUCHABLE);
	  depth3_mod_view.size_x = my_shadow.res;
	  depth3_mod_view.size_y = my_shadow.res;
	  depth3_view.material = depth_mat;	
	  depth_map_rtd3 = bmap_createblack(my_shadow.res,my_shadow.res,14);
	  bmap_to_format(depth_map_rtd3,14);
	  depth_map_rt2d3 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	  bmap_to_format(depth_map_rt2d3,14444);
	  set(depth3_view,SHOW);
	  depth3_view.bmap = depth_map_rtd3;		
	  depth3_view.stage = depth3_mod_view;
	  depth3_mod_view.bmap = depth_map_rt2d3;

	  if(is(my_shadow,DEPTHBLUR)) {
	    blur1d3 = view_create(-1);
	    set(blur1d3,PROCESS_TARGET | UNTOUCHABLE);
	    blur1d3.material = blur1_mat;	  
	    depth3_mod_view.stage = blur1d3;	    
	    depth_map_rtb1d3 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	    bmap_to_format(depth_map_rtb1d3,14444);
	    blur1d3.bmap = depth_map_rtb1d3;
	    ACDFSM_mat.skin3 = depth_map_rtb1d3;
     }
     else ACDFSM_mat.skin3 = depth_map_rt2d3;  
   }
	if(my_shadow.views >= 4) {   		
	  depth4_view = view_create(-1);
	  depth4_view.size_x = my_shadow.res;
	  depth4_view.size_y = my_shadow.res;
	  depth4_view.skill_x = 4;	 
	  set(depth4_view,UNTOUCHABLE | NOPARTICLE);	
	  depth4_mod_view = view_create(-1);
	  depth4_mod_view.material = depth_mod_mat;
	  set(depth4_mod_view,PROCESS_TARGET | UNTOUCHABLE);
	  depth4_mod_view.size_x = my_shadow.res;
	  depth4_mod_view.size_y = my_shadow.res;
	  depth4_view.material = depth_mat;	
	  depth_map_rtd4 = bmap_createblack(my_shadow.res,my_shadow.res,14);
	  bmap_to_format(depth_map_rtd4,14);
	  depth_map_rt2d4 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	  bmap_to_format(depth_map_rt2d4,14444);
	  
	  set(depth4_view,SHOW);
	  depth4_view.bmap = depth_map_rtd4;		
	  depth4_view.stage = depth4_mod_view;
	  depth4_mod_view.bmap = depth_map_rt2d4;
	  if(is(my_shadow,DEPTHBLUR)) {
	    blur1d4 = view_create(-1);
	    set(blur1d4,PROCESS_TARGET | UNTOUCHABLE);
	    blur1d4.material = blur1_mat;	  
	    depth4_mod_view.stage = blur1d4;	  
	    depth_map_rtb1d4 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	    bmap_to_format(depth_map_rtb1d4,14444);
	    blur1d4.bmap = depth_map_rtb1d4;
	    ACDFSM_mat.skin4 = depth_map_rtb1d4;
     }
     else ACDFSM_mat.skin4 = depth_map_rt2d4;     
   }   		
	VIEW* shadow_view = view_create(-1);
	shadow_view.material = ACDFSM_mat;
	shadow_view.size_x = screen_size.x;
	shadow_view.size_y = screen_size.y;	
	shadow_view.clip_near = camera.clip_near;
	shadow_view.arc = camera.arc;	
	set(shadow_view,UNTOUCHABLE | NOPARTICLE);		
	set(shadow_view,SHOW);	
	
	BMAP* depth_map_rt3 = bmap_createblack(screen_size.x,screen_size.y,32);
	VIEW* blur2; MATERIAL* blur2_mat;
	VIEW* blur3; MATERIAL* blur3_mat;	
	if(is(my_shadow,BLUR)) {
	  blur2_mat = mtl_create();
	  blur3_mat = mtl_create();	  
     blur2 = view_create(-1);
	  set(blur2,PROCESS_TARGET | UNTOUCHABLE);
	  blur2.material = blur2_mat;		
     blur3 = view_create(-1);
	  set(blur3,PROCESS_TARGET | UNTOUCHABLE);
	  blur3.material = blur3_mat;			  
	  shadow_view.stage = blur2;
	  blur2.stage = blur3;
	  blur3.bmap = depth_map_rt3;
   }
   else shadow_view.bmap = depth_map_rt3;
	if(my_shadow.id == 0) combi_mat.skin1 = depth_map_rt3;
	if(my_shadow.id == 1) combi_mat.skin2 = depth_map_rt3;
	if(my_shadow.id == 2) combi_mat.skin3 = depth_map_rt3;
	if(my_shadow.id == 3) combi_mat.skin4 = depth_map_rt3;
	if(my_shadow.id == 4) shadow5 = depth_map_rt3;
	if(my_shadow.id == 5) shadow6 = depth_map_rt3;
	if(my_shadow.id == 6) shadow7 = depth_map_rt3;
	
	depth_mat.event = Light_mat_event2;
	set(depth_mat,ENABLE_VIEW);
	if(my_shadow.views == 1) effect_load(ACDFSM_mat,"acdfsm_main.fx");	
	if(my_shadow.views == 2) effect_load(ACDFSM_mat,"acdfsm_main2.fx");	
	if(my_shadow.views == 3) effect_load(ACDFSM_mat,"acdfsm_main3.fx");	
	if(my_shadow.views == 4) effect_load(ACDFSM_mat,"acdfsm_main4.fx");	
	effect_load(depth_mod_mat,"acdfsm_dabc.fx");
	if(is(my_shadow,DEPTHBLUR)) effect_load(blur1_mat,"boxblur.fx");
   if(is(my_shadow,BLUR)) { effect_load(blur2_mat,"hblur.fx"); effect_load(blur3_mat,"vblur.fx"); }		
	wait(1);
	proc_mode = 0;	
	while(!my_shadow.change) {
	   vec_set(depth_view.x,sun_pos);
	   vec_normalize(depth_view.x,my_shadow.range);
	   if(is(my_shadow,MOVE_S)) vec_add(depth_view.x,camera.x);
	   depth_view.arc = my_shadow.arc;
		if(is(my_shadow,ROTATE_S)) {
		  vec_set(temp_vec,camera.x);
		  vec_sub(temp_vec,depth_view.x);
		  vec_to_angle(depth_view.pan,temp_vec);
	   }
	   else {
	     depth_view.pan = 180+sun_angle.pan;
   	  depth_view.tilt = -sun_angle.tilt;		
	   }
	   depth_view.clip_near = my_shadow.range/20;
	   depth_view.clip_far = my_shadow.range+10000+my_shadow.fade;
	   if(my_shadow.views >= 2) { 	   	  
	     vec_set(depth2_view.x,sun_pos);
	     vec_normalize(depth2_view.x,my_shadow.range);
	     if(is(my_shadow,MOVE_S)) vec_add(depth2_view.x,camera.x);
	     depth2_view.arc = depth_view.arc/4;
	     vec_set(depth2_view.pan,depth_view.pan);
	     depth2_view.clip_near = depth_view.clip_near;
	     depth2_view.clip_far = depth_view.clip_far;
      }
      if(my_shadow.views >= 3) { 
	     vec_set(depth3_view.x,sun_pos);
	     vec_normalize(depth3_view.x,my_shadow.range);
	     if(is(my_shadow,MOVE_S)) vec_add(depth3_view.x,camera.x);
	     depth3_view.arc = depth_view.arc/10;
	     vec_set(depth3_view.pan,depth_view.pan);	   
	     depth3_view.clip_near = depth_view.clip_near;
	     depth3_view.clip_far = depth_view.clip_far;
	   }
      if(my_shadow.views >= 4) { 
	     vec_set(depth4_view.x,sun_pos);
	     vec_normalize(depth4_view.x,my_shadow.range);
	     if(is(my_shadow,MOVE_S)) vec_add(depth4_view.x,camera.x);
	     depth4_view.arc = depth_view.arc/20;
	     vec_set(depth4_view.pan,depth_view.pan);	   
	     depth4_view.clip_near = depth_view.clip_near;
	     depth4_view.clip_far = depth_view.clip_far;
	   }	   
		vec_set(shadow_view.x,camera.x);
		vec_set(shadow_view.pan,camera.pan);
	   shadow_view.clip_far = my_shadow.fade;	
		if(is(my_shadow,BLUR)) {
        blur2_mat.skill1 = floatv(my_shadow.blur/100);
		  blur2_mat.skill2 = floatv(100/100);
		  blur3_mat.skill1 = floatv(my_shadow.blur/100);
		  blur3_mat.skill2 = floatv(100/100);
	   }
		depth_mod_mat.skill1 = floatv(my_shadow.res);
		if(is(my_shadow,DEPTHBLUR)) blur1_mat.skill1 = floatv(my_shadow.depth_blur/100);		
		depth_mod_mat.skill2 = floatv(integer(my_shadow.soften)/10);
		ACDFSM_mat.skill1 = floatv(integer(my_shadow.depth_bias)/10);
		ACDFSM_mat.skill2 = floatv(integer(my_shadow.brightness)/255);
		ACDFSM_mat.skill3 = floatv(shadow_view.clip_far/1.25);
		wait(1);
	}
	//depth_mat.event = NULL;
	//reset(depth_mat,ENABLE_VIEW);		
	reset(depth_view,SHOW);
	depth_view.bmap = NULL;	
	depth_view.stage = NULL;
	depth_mod_view.stage = NULL;
	depth_mod_view.bmap = NULL;
	ACDFSM_mat.skin1 = NULL;
	if(save_depth >= 2) {
	  reset(depth2_view,SHOW);
	  depth2_view.bmap = NULL;	
	  depth2_view.stage = NULL;
	  depth2_mod_view.stage = NULL;
	  depth2_mod_view.bmap = NULL;
	  ACDFSM_mat.skin2 = NULL;
   }
   if(save_depth >= 3) {
	  reset(depth3_view,SHOW);	
	  depth3_view.bmap = NULL;	
	  depth3_view.stage = NULL;
	  depth3_mod_view.stage = NULL;
	  depth3_mod_view.bmap = NULL;
	  ACDFSM_mat.skin3 = NULL;	
   }
   if(save_depth >= 4) {
	  reset(depth4_view,SHOW);	
	  depth4_view.bmap = NULL;	
	  depth4_view.stage = NULL;
	  depth4_mod_view.stage = NULL;
	  depth4_mod_view.bmap = NULL;
	  ACDFSM_mat.skin4 = NULL;	
   }   
	reset(shadow_view,SHOW);		
	shadow_view.stage = NULL;
	if(save_blur2) {
	  blur2.stage = NULL;
	  blur3.bmap = NULL;
   }
	if(my_shadow.id == 0) combi_mat.skin1 = NULL;
	if(my_shadow.id == 1) combi_mat.skin2 = NULL;
	if(my_shadow.id == 2) combi_mat.skin3 = NULL;
	if(my_shadow.id == 3) combi_mat.skin4 = NULL;
	if(my_shadow.id == 4) shadow5 = NULL;
	if(my_shadow.id == 5) shadow6 = NULL;
	if(my_shadow.id == 6) shadow7 = NULL;
	wait(1);
	ptr_remove(depth_view); depth_view = NULL;
	ptr_remove(depth_mod_view);  depth_mod_view = NULL;	
	bmap_remove(depth_map_rt); depth_map_rt = NULL;	
	bmap_remove(depth_map_rt2); depth_map_rt2 = NULL;		
	if(save_blur1) {
	  bmap_remove(depth_map_rtb1); depth_map_rtb1 = NULL;
	  ptr_remove(blur1); blur1 = NULL;
   }	
	if(save_depth >= 2) {
	  ptr_remove(depth2_view); depth2_view = NULL;
	  ptr_remove(depth2_mod_view);  depth2_mod_view = NULL;	
	  bmap_remove(depth_map_rtd2); depth_map_rtd2 = NULL;
	  bmap_remove(depth_map_rt2d2); depth_map_rt2d2 = NULL;		
	  if(save_blur1) {
	    bmap_remove(depth_map_rtb1d2); depth_map_rtb1d2 = NULL;
	    ptr_remove(blur1d2); blur1d2 = NULL;
     }
   }
   if(save_depth >= 3) {	
	  ptr_remove(depth3_view); depth3_view = NULL;	
	  ptr_remove(depth3_mod_view);  depth3_mod_view = NULL;		
	  bmap_remove(depth_map_rtd3); depth_map_rtd3 = NULL;
	  bmap_remove(depth_map_rt2d3); depth_map_rt2d3 = NULL;		
	  if(save_blur1) {
	    bmap_remove(depth_map_rtb1d3); depth_map_rtb1d3 = NULL;
	    ptr_remove(blur1d3); blur1d3 = NULL;
     }
   }
   if(save_depth >= 4) {	
	  ptr_remove(depth4_view); depth4_view = NULL;	
	  ptr_remove(depth4_mod_view);  depth4_mod_view = NULL;		
	  bmap_remove(depth_map_rtd4); depth_map_rtd4 = NULL;
	  bmap_remove(depth_map_rt2d4); depth_map_rt2d4 = NULL;		
	  if(save_blur1) {
	    bmap_remove(depth_map_rtb1d4); depth_map_rtb1d4 = NULL;
	    ptr_remove(blur1d4); blur1d4 = NULL;
     }
   }
   if(save_blur2) {
   	ptr_remove(blur2); blur2 = NULL; 
   	ptr_remove(blur3); blur3 = NULL; 
	   ptr_remove(blur2_mat);
	   ptr_remove(blur3_mat);	   		  	 	
   } 
   if(save_blur1) ptr_remove(blur1_mat);
   ptr_remove(ACDFSM_mat);
   ptr_remove(depth_mod_mat);     
	ptr_remove(shadow_view); shadow_view = NULL;
	//ptr_remove(combi_view); combi_view = NULL;
	bmap_remove(depth_map_rt3); depth_map_rt3 = NULL;	
	
	wait(2);
	do_shadowmapping(my_shadow);
}

function do_pointshadowmapping(SHADOW_STRUCT* my_shadow) {
	my_shadow.change = 0; if(!is(my_shadow,ACTIV)) return;
	var save_blur1; save_blur1 = is(my_shadow,DEPTHBLUR);
	var save_blur2; save_blur2 = is(my_shadow,BLUR);	
	proc_mode = PROC_LATE;
	MATERIAL* ACDFSM_mat; ACDFSM_mat = mtl_create();
	MATERIAL* depth_mod_mat; depth_mod_mat = mtl_create();			
	VIEW* depthp_view = view_create(-1);
	depthp_view.size_x = my_shadow.res;
	depthp_view.size_y = my_shadow.res;
	depthp_view.skill_x = 5;
	depthp_view.clip_near = 1;
	depthp_view.clip_far = my_shadow.range+200;
	set(depthp_view,UNTOUCHABLE | NOPARTICLE);
	VIEW* depthp_mod_view = view_create(-1);
	depthp_mod_view.material = depth_mod_mat;
	set(depthp_mod_view,PROCESS_TARGET | UNTOUCHABLE);
	depthp_mod_view.size_x = my_shadow.res;
	depthp_mod_view.size_y = my_shadow.res;
	depthp_view.material = depth_mat;
	BMAP* depthp_map_rt = bmap_createblack(my_shadow.res,my_shadow.res,14);
	bmap_to_format(depthp_map_rt,14);
	BMAP* depthp_map_rt2 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	bmap_to_format(depthp_map_rt2,14444);
	set(depthp_view,SHOW);
	depthp_view.bmap = depthp_map_rt;
	depthp_view.stage = depthp_mod_view;
	depthp_mod_view.bmap = depthp_map_rt2;	
	depthp_view.arc = 90;	
	depthp_view.skill_y = ACDFSM_mat;
	VIEW* depthp2_view = view_create(-1);
	depthp2_view.size_x = my_shadow.res;
	depthp2_view.size_y = my_shadow.res;
	depthp2_view.skill_x = 5;	
	depthp2_view.clip_near = 1;
	depthp2_view.clip_far = 500+200;
	set(depthp2_view,UNTOUCHABLE | NOPARTICLE);
	VIEW* depthp2_mod_view = view_create(-1);
	depthp2_mod_view.material = depth_mod_mat;
	set(depthp2_mod_view,PROCESS_TARGET | UNTOUCHABLE);
	depthp2_mod_view.size_x = my_shadow.res;
	depthp2_mod_view.size_y = my_shadow.res;
	depthp2_view.material = depth_mat;
	BMAP* depthp_map_rtr2 = bmap_createblack(my_shadow.res,my_shadow.res,14);
	bmap_to_format(depthp_map_rtr2,14);
	BMAP* depthp_map_rt2r2 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	bmap_to_format(depthp_map_rt2r2,14444);
	set(depthp2_view,SHOW);
	depthp2_view.bmap = depthp_map_rt;
	depthp2_view.stage = depthp2_mod_view;
	depthp2_mod_view.bmap = depthp_map_rt2r2;
	depthp2_view.arc = 90;	
	depthp2_view.skill_y = ACDFSM_mat;
	VIEW* depthp3_view = view_create(-1);
	depthp3_view.size_x = my_shadow.res;
	depthp3_view.size_y = my_shadow.res;
	depthp3_view.skill_x = 5;	
	depthp3_view.clip_near = 1;
	depthp3_view.clip_far = 500+200;
	set(depthp3_view,UNTOUCHABLE | NOPARTICLE);
	VIEW* depthp3_mod_view = view_create(-1);
	depthp3_mod_view.material = depth_mod_mat;
	set(depthp3_mod_view,PROCESS_TARGET | UNTOUCHABLE);
	depthp3_mod_view.size_x = my_shadow.res;
	depthp3_mod_view.size_y = my_shadow.res;
	depthp3_view.material = depth_mat;
	BMAP* depthp_map_rtr3 = bmap_createblack(my_shadow.res,my_shadow.res,14);
	bmap_to_format(depthp_map_rtr3,14);
	BMAP* depthp_map_rt2r3 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	bmap_to_format(depthp_map_rt2r3,14444);
	set(depthp3_view,SHOW);
	depthp3_view.bmap = depthp_map_rtr3;
	depthp3_view.stage = depthp3_mod_view;
	depthp3_mod_view.bmap = depthp_map_rt2r3;
	depthp3_view.arc = 90;	
	depthp3_view.skill_y = ACDFSM_mat;
	VIEW* depthp4_view = view_create(-1);
	depthp4_view.size_x = my_shadow.res;
	depthp4_view.size_y = my_shadow.res;
	depthp4_view.skill_x = 5;		
	depthp4_view.clip_near = 1;
	depthp4_view.clip_far = 500+200;
	set(depthp4_view,UNTOUCHABLE | NOPARTICLE);
	VIEW* depthp4_mod_view = view_create(-1);
	depthp4_mod_view.material = depth_mod_mat;
	set(depthp4_mod_view,PROCESS_TARGET | UNTOUCHABLE);
	depthp4_mod_view.size_x = my_shadow.res;
	depthp4_mod_view.size_y = my_shadow.res;
	depthp4_view.material = depth_mat;
	BMAP* depthp_map_rtr4 = bmap_createblack(my_shadow.res,my_shadow.res,14);
	bmap_to_format(depthp_map_rtr4,14);
	BMAP* depthp_map_rt2r4 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	bmap_to_format(depthp_map_rt2r4,14444);
	set(depthp4_view,SHOW);
	depthp4_view.bmap = depthp_map_rtr4;
	depthp4_view.stage = depthp4_mod_view;
	depthp4_mod_view.bmap = depthp_map_rt2r4;
	depthp4_view.arc = 90;	
	depthp4_view.skill_y = ACDFSM_mat;
	VIEW* depthp5_view = view_create(-1);
	depthp5_view.size_x = my_shadow.res;
	depthp5_view.size_y = my_shadow.res;
	depthp5_view.skill_x = 5;		
	depthp5_view.clip_near = 1;
	depthp5_view.clip_far = 500+200;
	set(depthp5_view,UNTOUCHABLE | NOPARTICLE);
	VIEW* depthp5_mod_view = view_create(-1);
	depthp5_mod_view.material = depth_mod_mat;
	set(depthp5_mod_view,PROCESS_TARGET | UNTOUCHABLE);
	depthp5_mod_view.size_x = my_shadow.res;
	depthp5_mod_view.size_y = my_shadow.res;
	depthp5_view.material = depth_mat;
	BMAP* depthp_map_rtr5 = bmap_createblack(my_shadow.res,my_shadow.res,14);
	bmap_to_format(depthp_map_rtr5,14);
	BMAP* depthp_map_rt2r5 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	bmap_to_format(depthp_map_rt2r5,14444);
	set(depthp5_view,SHOW);
	depthp5_view.bmap = depthp_map_rtr5;
	depthp5_view.stage = depthp5_mod_view;
	depthp5_mod_view.bmap = depthp_map_rt2r5;
	depthp5_view.arc = 90;	
	depthp5_view.skill_y = ACDFSM_mat;
	VIEW* depthp6_view = view_create(-1);
	depthp6_view.size_x = my_shadow.res;
	depthp6_view.size_y = my_shadow.res;
	depthp6_view.skill_x = 5;		
	depthp6_view.clip_near = 1;
	depthp6_view.clip_far = 500+200;
	set(depthp6_view,UNTOUCHABLE | NOPARTICLE);
	VIEW* depthp6_mod_view = view_create(-1);
	depthp6_mod_view.material = depth_mod_mat;
	set(depthp6_mod_view,PROCESS_TARGET | UNTOUCHABLE);
	depthp6_mod_view.size_x = my_shadow.res;
	depthp6_mod_view.size_y = my_shadow.res;
	depthp6_view.material = depth_mat;
	BMAP* depthp_map_rtr6 = bmap_createblack(my_shadow.res,my_shadow.res,14);
	bmap_to_format(depthp_map_rtr6,14);
	BMAP* depthp_map_rt2r6 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	bmap_to_format(depthp_map_rt2r6,14444);
	set(depthp6_view,SHOW);
	depthp6_view.bmap = depthp_map_rtr6;
	depthp6_view.stage = depthp6_mod_view;
	depthp6_mod_view.bmap = depthp_map_rt2r6;
	depthp6_view.arc = 90;	
	depthp6_view.skill_y = ACDFSM_mat;	
	BMAP* depthp_map_rtb1;BMAP* depthp_map_rtb1r2;BMAP* depthp_map_rtb1r3;BMAP* depthp_map_rtb1r4;BMAP* depthp_map_rtb1r5;BMAP* depthp_map_rtb1r6;
	VIEW* blur1p; VIEW* blur1pr2; VIEW* blur1pr3; VIEW* blur1pr4; VIEW* blur1pr5; VIEW* blur1pr6;
	MATERIAL* blur1_mat;
	if(is(my_shadow,DEPTHBLUR)) {
	blur1_mat = mtl_create();
	depthp_map_rtb1 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	bmap_to_format(depthp_map_rtb1,14444);
	blur1p = view_create(-1);
	set(blur1p,PROCESS_TARGET | UNTOUCHABLE);
	blur1p.material = blur1_mat;
	depthp_mod_view.stage = blur1p;
	blur1p.bmap = depthp_map_rtb1;
	ACDFSM_mat.skin1 = depthp_map_rtb1;	
	depthp_map_rtb1r2 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	bmap_to_format(depthp_map_rtb1r2,14444);
	blur1pr2 = view_create(-1);
	set(blur1pr2,PROCESS_TARGET | UNTOUCHABLE);
	blur1pr2.material = blur1_mat;	
	depthp2_mod_view.stage = blur1pr2;
	blur1pr2.bmap = depthp_map_rtb1r2;
	ACDFSM_mat.skin2 = depthp_map_rtb1r2;	
	depthp_map_rtb1r3 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	bmap_to_format(depthp_map_rtb1r3,14444);
	blur1pr3 = view_create(-1);
	set(blur1pr3,PROCESS_TARGET | UNTOUCHABLE);
	blur1pr3.material = blur1_mat;		
	depthp3_mod_view.stage = blur1pr3;
	blur1pr3.bmap = depthp_map_rtb1r3;
	ACDFSM_mat.skin3 = depthp_map_rtb1r3;	
	depthp_map_rtb1r4 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	bmap_to_format(depthp_map_rtb1r4,14444);
	blur1pr4 = view_create(-1);
	set(blur1pr4,PROCESS_TARGET | UNTOUCHABLE);
	blur1pr4.material = blur1_mat;		
	depthp4_mod_view.stage = blur1pr4;
	blur1pr4.bmap = depthp_map_rtb1r4;
	ACDFSM_mat.skin4 = depthp_map_rtb1r4;	
	depthp_map_rtb1r5 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	bmap_to_format(depthp_map_rtb1r5,14444);
	blur1pr5 = view_create(-1);
	set(blur1pr5,PROCESS_TARGET | UNTOUCHABLE);
	blur1pr5.material = blur1_mat;		
	depthp5_mod_view.stage = blur1pr5;
	blur1pr5.bmap = depthp_map_rtb1r5;
	depth5_a = depthp_map_rtb1r5;	
	depthp_map_rtb1r6 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	bmap_to_format(depthp_map_rtb1r6,14444);
	blur1pr6 = view_create(-1);
	set(blur1pr6,PROCESS_TARGET | UNTOUCHABLE);
	blur1pr6.material = blur1_mat;		
	depthp6_mod_view.stage = blur1pr6;
	blur1pr6.bmap = depthp_map_rtb1r6;
	depth6_a = depthp_map_rtb1r6;
   }
   else {
	ACDFSM_mat.skin1 = depthp_map_rt2;	
	ACDFSM_mat.skin2 = depthp_map_rt2r2;	
	ACDFSM_mat.skin3 = depthp_map_rt2r3;	
	ACDFSM_mat.skin4 = depthp_map_rt2r4;	
	depth5_a = depthp_map_rt2r5;	
	depth6_a = depthp_map_rt2r6;	  	
   }
	VIEW* shadowp_view = view_create(-1);
	shadowp_view.material = ACDFSM_mat;
	shadowp_view.size_x = screen_size.x;
	shadowp_view.size_y = screen_size.y;
	shadowp_view.clip_near = camera.clip_near;
	shadowp_view.arc = camera.arc;		
	BMAP* depthp_map_rt3 = bmap_createblack(screen_size.x,screen_size.y,32);
	set(shadowp_view,SHOW| UNTOUCHABLE );	
	VIEW* blur2p; MATERIAL* blur2_mat;
	VIEW* blur3p; MATERIAL* blur3_mat;
	if(is(my_shadow,BLUR)) {
	  blur2_mat = mtl_create();
	  blur3_mat = mtl_create();
     blur2p = view_create(-1);
	  set(blur2p,PROCESS_TARGET | UNTOUCHABLE);
	  blur2p.material = blur2_mat;		
     blur3p = view_create(-1);
	  set(blur3p,PROCESS_TARGET | UNTOUCHABLE);
	  blur3p.material = blur3_mat;			  	  
	  shadowp_view.stage = blur2p;
	  blur2p.stage = blur3p;
	  blur3p.bmap = depthp_map_rt3;
   }
   else shadowp_view.bmap = depthp_map_rt3;	
	if(my_shadow.id == 0) combi_mat.skin1 = depthp_map_rt3;
	if(my_shadow.id == 1) combi_mat.skin2 = depthp_map_rt3;
	if(my_shadow.id == 2) combi_mat.skin3 = depthp_map_rt3;
	if(my_shadow.id == 3) combi_mat.skin4 = depthp_map_rt3;
	if(my_shadow.id == 4) shadow5 = depthp_map_rt3;
	if(my_shadow.id == 5) shadow6 = depthp_map_rt3;
	if(my_shadow.id == 6) shadow7 = depthp_map_rt3;
	depth_mat.event = Light_mat_event2;
	set(depth_mat,ENABLE_VIEW);	
	   depthp_view.pan = 0;
   	depthp_view.tilt = 0;
   if(is(my_shadow,BLUR)) { effect_load(blur2_mat,"hblur.fx"); effect_load(blur3_mat,"vblur.fx"); }		
   effect_load(depth_mod_mat,"acdfsm_dabc.fx");
   effect_load(ACDFSM_mat,"acdfsm_mainp.fx");      	
	if(is(my_shadow,DEPTHBLUR)) effect_load(blur1_mat,"boxblur.fx");   	
   	wait(1);
		proc_mode = 0;		
	while(!my_shadow.change) {
	   vec_set(depthp_view.x,my_shadow.light.x);
	   vec_set(depthp_view.pan,my_shadow.light.pan);
	   vec_set(depthp2_view.x,depthp_view.x);
	   vec_set(depthp2_view.pan,depthp_view.pan);
	   depthp2_view.pan += 90;
	   vec_set(depthp3_view.x,depthp_view.x);
	   vec_set(depthp3_view.pan,depthp_view.pan);
	   depthp3_view.pan += 180;
	   vec_set(depthp4_view.x,depthp_view.x);
	   vec_set(depthp4_view.pan,depthp_view.pan);
	   depthp4_view.pan += 270;
	   vec_set(depthp5_view.x,depthp_view.x);
	   vec_set(depthp5_view.pan,depthp_view.pan);
	   depthp5_view.tilt += 90;
	   vec_set(depthp6_view.x,depthp_view.x);
	   vec_set(depthp6_view.pan,depthp_view.pan);
	   depthp6_view.tilt -= 90;		
		vec_set(shadowp_view.x,camera.x);
		vec_set(shadowp_view.pan,camera.pan);
		shadowp_view.clip_far = my_shadow.fade;
		if(is(my_shadow,BLUR)) {
        blur2_mat.skill1 = floatv(my_shadow.blur/100);
		  blur2_mat.skill2 = floatv(100/100);
		  blur3_mat.skill1 = floatv(my_shadow.blur/100);
		  blur3_mat.skill2 = floatv(100/100);
	   }
		if(is(my_shadow,DEPTHBLUR)) blur1_mat.skill1 = floatv(my_shadow.depth_blur/100);			   		
		depth_mod_mat.skill1 = floatv(my_shadow.res);
		depth_mod_mat.skill2 = floatv(integer(my_shadow.soften)/10);
		ACDFSM_mat.skill1 = floatv(integer(my_shadow.depth_bias)/10);
		ACDFSM_mat.skill2 = floatv(integer(my_shadow.brightness)/255);
		ACDFSM_mat.skill3 = floatv(shadowp_view.clip_far/1.25);
		ACDFSM_mat.skill5 = floatv(my_shadow.light.x);
		ACDFSM_mat.skill6 = floatv(my_shadow.light.z);
		ACDFSM_mat.skill7 = floatv(my_shadow.light.y);
		
		wait(1);
	}
	reset(depthp_view,SHOW);
	depthp_view.bmap = NULL;	
	depthp_view.stage = NULL;
	depthp_mod_view.stage = NULL;
	depthp_mod_view.bmap = NULL;
	ACDFSM_mat.skin1 = NULL;
	reset(depthp2_view,SHOW);
	depthp2_view.bmap = NULL;	
	depthp2_view.stage = NULL;
	depthp2_mod_view.stage = NULL;
	depthp2_mod_view.bmap = NULL;
	ACDFSM_mat.skin2 = NULL;
	reset(depthp3_view,SHOW);
	depthp3_view.bmap = NULL;	
	depthp3_view.stage = NULL;
	depthp3_mod_view.stage = NULL;
	depthp3_mod_view.bmap = NULL;
	ACDFSM_mat.skin3 = NULL;
	reset(depthp4_view,SHOW);
	depthp4_view.bmap = NULL;	
	depthp4_view.stage = NULL;
	depthp4_mod_view.stage = NULL;
	depthp4_mod_view.bmap = NULL;
	ACDFSM_mat.skin4 = NULL;
	reset(depthp5_view,SHOW);
	depthp5_view.bmap = NULL;	
	depthp5_view.stage = NULL;
	depthp5_mod_view.stage = NULL;
	depthp5_mod_view.bmap = NULL;
	depth5_a = NULL;
	reset(depthp6_view,SHOW);
	depthp6_view.bmap = NULL;	
	depthp6_view.stage = NULL;
	depthp6_mod_view.stage = NULL;
	depthp6_mod_view.bmap = NULL;
	depth6_a = NULL;	
	reset(shadowp_view,SHOW);	
	//camera.stage = NULL;	
	shadowp_view.stage = NULL;
	if(my_shadow.id == 0) combi_mat.skin1 = NULL;
	if(my_shadow.id == 1) combi_mat.skin2 = NULL;
	if(my_shadow.id == 2) combi_mat.skin3 = NULL;
	if(my_shadow.id == 3) combi_mat.skin4 = NULL;
	if(my_shadow.id == 4) shadow5 = NULL;
	if(my_shadow.id == 5) shadow6 = NULL;
	if(my_shadow.id == 6) shadow7 = NULL;
	wait(1);
	if(save_blur2) {
		blur2p.stage = NULL;
		blur3p.bmap = NULL;
	   ptr_remove(blur2p); 
	   ptr_remove(blur3p);
	   ptr_remove(blur2_mat);
	   ptr_remove(blur3_mat);	   		
	}
	ptr_remove(depthp_view); depthp_view = NULL;
	ptr_remove(depthp_mod_view);  depthp_mod_view = NULL;
	bmap_remove(depthp_map_rt); depthp_map_rt = NULL;
	bmap_remove(depthp_map_rt2); depthp_map_rt2 = NULL;
	ptr_remove(depthp2_view); depthp2_view = NULL;
	ptr_remove(depthp2_mod_view);  depthp2_mod_view = NULL;
	bmap_remove(depthp_map_rtr2); depthp_map_rtr2 = NULL;
	bmap_remove(depthp_map_rt2r2); depthp_map_rt2r2 = NULL;
	ptr_remove(depthp3_view); depthp3_view = NULL;
	ptr_remove(depthp3_mod_view);  depthp3_mod_view = NULL;
	bmap_remove(depthp_map_rtr3); depthp_map_rtr3 = NULL;
	bmap_remove(depthp_map_rt2r3); depthp_map_rt2r3 = NULL;
	ptr_remove(depthp4_view); depthp4_view = NULL;
	ptr_remove(depthp4_mod_view);  depthp4_mod_view = NULL;
	bmap_remove(depthp_map_rtr4); depthp_map_rtr4 = NULL;
	bmap_remove(depthp_map_rt2r4); depthp_map_rt2r4 = NULL;
	ptr_remove(depthp5_view); depthp5_view = NULL;
	ptr_remove(depthp5_mod_view);  depthp5_mod_view = NULL;
	bmap_remove(depthp_map_rtr5); depthp_map_rtr5 = NULL;
	bmap_remove(depthp_map_rt2r5); depthp_map_rt2r5 = NULL;
	ptr_remove(depthp6_view); depthp6_view = NULL;
	ptr_remove(depthp6_mod_view);  depthp6_mod_view = NULL;
	bmap_remove(depthp_map_rtr6); depthp_map_rtr6 = NULL;
	bmap_remove(depthp_map_rt2r6); depthp_map_rt2r6 = NULL;
	ptr_remove(shadowp_view); shadowp_view = NULL;
	bmap_remove(depthp_map_rt3); depthp_map_rt3 = NULL;
   if(save_blur1) {
	ptr_remove(blur1p); blur1p = NULL;
	ptr_remove(blur1pr2); blur1pr2 = NULL;
	ptr_remove(blur1pr3); blur1pr3 = NULL;
	ptr_remove(blur1pr4); blur1pr4 = NULL;
	ptr_remove(blur1pr5); blur1pr5 = NULL;
	ptr_remove(blur1pr6); blur1pr6 = NULL;	
	bmap_remove(depthp_map_rtb1); depthp_map_rtb1 = NULL;
	bmap_remove(depthp_map_rtb1r2); depthp_map_rtb1r2 = NULL;
	bmap_remove(depthp_map_rtb1r3); depthp_map_rtb1r3 = NULL;
	bmap_remove(depthp_map_rtb1r4); depthp_map_rtb1r4 = NULL;	
	bmap_remove(depthp_map_rtb1r5); depthp_map_rtb1r5 = NULL;	
	bmap_remove(depthp_map_rtb1r6); depthp_map_rtb1r6 = NULL;	
   ptr_remove(blur1_mat);
   }
   ptr_remove(ACDFSM_mat);
   ptr_remove(depth_mod_mat);
	wait(2);
	do_pointshadowmapping(my_shadow);
}

function do_spotshadowmapping(SHADOW_STRUCT* my_shadow) {
	my_shadow.change = 0; if(!is(my_shadow,ACTIV)) return;
		proc_mode = PROC_LATE;	
	var save_blur1; save_blur1 = is(my_shadow,DEPTHBLUR);
	var save_blur2; save_blur2 = is(my_shadow,BLUR);	
	
	VIEW* mydepth_view; mydepth_view = view_create(-1);
	mydepth_view.size_x = my_shadow.res;
	mydepth_view.size_y = my_shadow.res;
	mydepth_view.skill_x = 6;
	set(mydepth_view,UNTOUCHABLE | NOPARTICLE);
	MATERIAL* depth_mod_mat = mtl_create();
	VIEW* mydepth_mod_view;mydepth_mod_view = view_create(-1);
	mydepth_mod_view.material = depth_mod_mat;
	set(mydepth_mod_view,PROCESS_TARGET | UNTOUCHABLE);
	mydepth_mod_view.size_x = my_shadow.res;
	mydepth_mod_view.size_y = my_shadow.res;	
	mydepth_view.material = depth_mat;
	BMAP* mydepth_map_rt; mydepth_map_rt = bmap_createblack(my_shadow.res,my_shadow.res,14);
	bmap_to_format(mydepth_map_rt,14);
	BMAP* mydepth_map_rt2; mydepth_map_rt2 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	bmap_to_format(mydepth_map_rt2,14444);
	set(mydepth_view,SHOW);
	mydepth_view.bmap = mydepth_map_rt;	
	mydepth_view.stage = mydepth_mod_view;
	mydepth_mod_view.bmap = mydepth_map_rt2;
	MATERIAL* myACDFSM_mat; myACDFSM_mat = mtl_create();
	//set(myACDFSM_mat,AUTORELOAD);
	BMAP* mydepth_map_rtb1;	
	VIEW* myblur1;	MATERIAL* blur1_mat;
	if(is(my_shadow,DEPTHBLUR)) {
	  blur1_mat = mtl_create();
     mydepth_map_rtb1 = bmap_createblack(my_shadow.res,my_shadow.res,128);
	  bmap_to_format(mydepth_map_rtb1,14444);
     myblur1 = view_create(-1);
	  set(myblur1,PROCESS_TARGET | UNTOUCHABLE);
	  myblur1.material = blur1_mat;
	  mydepth_mod_view.stage = myblur1;
	  myblur1.bmap = mydepth_map_rtb1;
	  myACDFSM_mat.skin1 = mydepth_map_rtb1;	
   }
   else myACDFSM_mat.skin1 = mydepth_map_rt2;
	VIEW* myshadow_view; myshadow_view = view_create(-1);
	myshadow_view.material = myACDFSM_mat;
	myshadow_view.size_x = screen_size.x;
	myshadow_view.size_y = screen_size.y;	
	myshadow_view.clip_near = camera.clip_near;
	myshadow_view.arc = camera.arc;	
	set(myshadow_view,UNTOUCHABLE | NOPARTICLE);	
	mydepth_view.skill_y = myACDFSM_mat;
	
	BMAP* mydepth_map_rt3; mydepth_map_rt3 = bmap_createblack(screen_size.x,screen_size.y,32);
	set(myshadow_view,SHOW);	
	VIEW* myblur2; MATERIAL* blur2_mat;
	VIEW* myblur3;	MATERIAL* blur3_mat;		
	if(is(my_shadow,BLUR)) {
		 blur2_mat = mtl_create();
		 blur3_mat = mtl_create();		 
		 myblur2 = view_create(-1);
		 myblur3 = view_create(-1);	
		set(myblur2,PROCESS_TARGET | UNTOUCHABLE);
		set(myblur3,PROCESS_TARGET | UNTOUCHABLE);
	   myblur2.material = blur2_mat;
	   myblur3.material = blur3_mat;				
	   myshadow_view.stage = myblur2;
      myblur2.stage = myblur3;
	   myblur3.bmap = mydepth_map_rt3;
   }
   else myshadow_view.bmap = mydepth_map_rt3;
	if(my_shadow.id == 0) combi_mat.skin1 = mydepth_map_rt3;
	if(my_shadow.id == 1) combi_mat.skin2 = mydepth_map_rt3;
	if(my_shadow.id == 2) combi_mat.skin3 = mydepth_map_rt3;
	if(my_shadow.id == 3) combi_mat.skin4 = mydepth_map_rt3;
	if(my_shadow.id == 4) shadow5 = mydepth_map_rt3;
	if(my_shadow.id == 5) shadow6 = mydepth_map_rt3;
	if(my_shadow.id == 6) shadow7 = mydepth_map_rt3;
   effect_load(myACDFSM_mat,"acdfsm_mains.fx");		
	effect_load(depth_mod_mat,"acdfsm_dabc.fx");
	if(is(my_shadow,DEPTHBLUR)) effect_load(blur1_mat,"boxblur.fx");
   if(is(my_shadow,BLUR)) { effect_load(blur2_mat,"hblur.fx"); effect_load(blur3_mat,"vblur.fx"); }		
	wait(1);
	proc_mode = 0;	
	while(!my_shadow.change) {
	   vec_set(mydepth_view.x,my_shadow.light.x);
	   mydepth_view.arc = my_shadow.arc;
      vec_set(mydepth_view.pan,my_shadow.light.pan);
	   mydepth_view.clip_near = 5;
	   mydepth_view.clip_far = my_shadow.range+500;
		vec_set(myshadow_view.x,camera.x);
		vec_set(myshadow_view.pan,camera.pan);
	   myshadow_view.clip_far = my_shadow.fade;	
		if(is(my_shadow,BLUR)) {
        blur2_mat.skill1 = floatv(my_shadow.blur/100);
		  blur2_mat.skill2 = floatv(100/100);
		  blur3_mat.skill1 = floatv(my_shadow.blur/100);
		  blur3_mat.skill2 = floatv(100/100);
	   }
		if(is(my_shadow,DEPTHBLUR)) blur1_mat.skill1 = floatv(my_shadow.depth_blur/100);			   		
		depth_mod_mat.skill1 = floatv(my_shadow.res);
		depth_mod_mat.skill2 = floatv(integer(my_shadow.soften)/10);				
		myACDFSM_mat.skill1 = floatv(integer(my_shadow.depth_bias)/10);
		myACDFSM_mat.skill2 = floatv(integer(my_shadow.brightness)/255);
		myACDFSM_mat.skill3 = floatv(myshadow_view.clip_far/1.25);
		myACDFSM_mat.skill5 = floatv(my_shadow.light.x);
		myACDFSM_mat.skill6 = floatv(my_shadow.light.z);
		myACDFSM_mat.skill7 = floatv(my_shadow.light.y);
		myACDFSM_mat.skill9 = floatv(cos(my_shadow.light.pan)*cos(my_shadow.light.tilt));
		myACDFSM_mat.skill10 = floatv(sin(my_shadow.light.tilt));
		myACDFSM_mat.skill11 = floatv(sin(my_shadow.light.pan)*cos(my_shadow.light.tilt));
		myACDFSM_mat.skill12 = floatv(1-(cos(mydepth_view.arc/2)));				
		wait(1);
	}
	reset(mydepth_view,SHOW);
	mydepth_view.bmap = NULL;	
	mydepth_view.stage = NULL;
	mydepth_mod_view.stage = NULL;
	mydepth_mod_view.bmap = NULL;
	myACDFSM_mat.skin1 = NULL;
	reset(myshadow_view,SHOW);		
	myshadow_view.stage = NULL;
	if(my_shadow.id == 0) combi_mat.skin1 = NULL;
	if(my_shadow.id == 1) combi_mat.skin2 = NULL;
	if(my_shadow.id == 2) combi_mat.skin3 = NULL;
	if(my_shadow.id == 3) combi_mat.skin4 = NULL;
	if(my_shadow.id == 4) shadow5 = NULL;
	if(my_shadow.id == 5) shadow6 = NULL;
	if(my_shadow.id == 6) shadow7 = NULL; 
   if(save_blur2) {
   	myblur2.stage = NULL; myblur3.bmap = NULL; 
   	ptr_remove(myblur2); myblur2 = NULL;
   	ptr_remove(myblur3); myblur3 = NULL;
	   ptr_remove(blur2_mat);	   
	   ptr_remove(blur3_mat);	   
   }
	wait(1);
	ptr_remove(mydepth_view); mydepth_view = NULL;
	ptr_remove(mydepth_mod_view);  mydepth_mod_view = NULL;	
	bmap_remove(mydepth_map_rt); mydepth_map_rt = NULL;	
	bmap_remove(mydepth_map_rt2); mydepth_map_rt2 = NULL;		
	ptr_remove(myshadow_view); myshadow_view = NULL;
	bmap_remove(mydepth_map_rt3); mydepth_map_rt3 = NULL;	
	if(save_blur1) {
	   bmap_remove(mydepth_map_rtb1); mydepth_map_rtb1 = NULL;
	   ptr_remove(myblur1); myblur1 = NULL;
	   ptr_remove(blur1_mat);	   
	}
	ptr_remove(myACDFSM_mat);
	ptr_remove(depth_mod_mat);
	wait(2);
	do_spotshadowmapping(my_shadow);
}

SHADOW_STRUCT* copy_light(SHADOW_STRUCT* src) {
 SHADOW_STRUCT* new_obj = malloc(sizeof(SHADOW_STRUCT));
 new_obj.light = src.light;
 new_obj.flags = src.flags;
 new_obj.res = src.res;
 new_obj.views = src.views;
 new_obj.change = 0;
 new_obj.range = src.range;
 new_obj.fade = src.fade;
 new_obj.arc = src.arc; 
 new_obj.soften = src.soften;
 new_obj.depth_blur = src.depth_blur;
 new_obj.blur = src.blur;
 new_obj.depth_bias = src.depth_bias;
 new_obj.brightness = src.brightness;
 return(new_obj);
}

function init_shadows(start,mode,amount) {
	if(start == 1)combi_view = view_create(0);
	if(start == 1) combi_view.material = combi_mat;
	if(amount <= 1)effect_load(combi_mat,"acdfsm_combinescene.fx");
	if(amount == 2)effect_load(combi_mat,"acdfsm_combinescene2.fx");
	if(amount == 3)effect_load(combi_mat,"acdfsm_combinescene3.fx");
	if(amount == 4)effect_load(combi_mat,"acdfsm_combinescene4.fx");
	if(amount == 5)effect_load(combi_mat,"acdfsm_combinescene5.fx");
	if(amount == 6)effect_load(combi_mat,"acdfsm_combinescene6.fx");
	if(amount >= 7)effect_load(combi_mat,"acdfsm_combinescene7.fx");		
	if(start == 1) set(combi_view,PROCESS_TARGET | UNTOUCHABLE);		
	if(start == 1) camera.stage = combi_view;		
   if(mode == 1) { temp_shadow = copy_light(sun_shadow); shadowlights[num_shadowlights] = temp_shadow; temp_shadow.id = num_shadowlights; num_shadowlights += 1; do_shadowmapping(temp_shadow);   }
   if(start != 1) return;
   while(1) {
   	combi_mat.skill1 = floatv(shadow_brightness/100);
   	wait(1);
   }
}


///////////////////////////////////////////////////////depth events//////////////////////////////////////////////////////////

void Light_mat_event2()
{
			float fTexAdj[16] =
		{ 0.5, 0.0, 0.0, 0.0,
		  0.0,-0.5,	0.0, 0.0,
		  0.0, 0.0, 1.0, 0.0,
		  0.0, 0.0, 0.0, 1.0 };
		  
		fTexAdj[12] = 0.5 + (0.5/(float)render_view.size_x);
		fTexAdj[13] = 0.5 + (0.5/(float)render_view.size_y);
   if(render_view.skill_x == 1) {
	  mat_set(((MATERIAL*)render_view.skill_y).matrix,matViewProj);	
     mat_multiply(((MATERIAL*)render_view.skill_y).matrix,fTexAdj);           	
   }
	if(render_view.skill_x == 2) {
	  mat_set(lmatrix1,matViewProj);	
     mat_multiply(lmatrix1,fTexAdj); 
	  mat_effect1 = lmatrix1;	
   }
   if(render_view.skill_x == 3) {
	  mat_set(lmatrix2,matViewProj);	
     mat_multiply(lmatrix2,fTexAdj); 
	  mat_effect2 = lmatrix2;	
   } 
   if(render_view.skill_x == 4) {
	  mat_set(lmatrix3,matViewProj);	
     mat_multiply(lmatrix3,fTexAdj); 
	  mat_effect3 = lmatrix3;	
   } 
  if(render_view.skill_x == 5) {   
	  mat_set(((MATERIAL*)render_view.skill_y).matrix,matProj);	
     mat_multiply(((MATERIAL*)render_view.skill_y).matrix,fTexAdj); 
  } 
   if(render_view.skill_x == 6) {
	  mat_set(((MATERIAL*)render_view.skill_y).matrix,matViewProj);	
     mat_multiply(((MATERIAL*)render_view.skill_y).matrix,fTexAdj);           	
   }
	return 0;	
}

action my_pointlight() {
	wait(1);
	my.pan = 0; //it's very important that the pointlight has no angle applied!
	my.tilt = 0;
	my.roll = 0;
	set(my,INVISIBLE);
	if(my.skill1) my.lightrange = clamp(my.skill1,5,20000);
	else my.lightrange = 500;
	if(my.skill2 || my.skill3 || my.skill4) { my.red = clamp(my.skill2,0,255); my.green = clamp(my.skill3,0,255); clamp(my.blue = my.skill4,0,255); }
	else { my.red = 255; my.green = 255; my.blue = 255; }
   SHADOW_STRUCT* my_shadow = malloc(sizeof(SHADOW_STRUCT));
   my_shadow.light = my;
   my_shadow.res = 0;
   if(my.skill5 == 128) my_shadow.res = 128; if(my.skill5 == 256) my_shadow.res = 256; if(my.skill5 == 512) my_shadow.res = 512; if(my.skill5 == 1024) my_shadow.res = 1024; if(my.skill5 == 2048) my_shadow.res = 2048;
   if(!my_shadow.res) my_shadow.res = 256;  
   my_shadow.range = my.lightrange;
   my_shadow.fade = 6000;
   my_shadow.arc = 0;
   my_shadow.soften = 120;
   my_shadow.depth_bias = 40;
   my_shadow.depth_blur = 30;
   my_shadow.blur = 70;
   my_shadow.brightness = 10;
   my_shadow.flags = POINTLIGHT_P | DEPTHBLUR | ACTIV;
   my_shadow.views = 1;
   my_shadow.change = 0;
   shadowlights[num_shadowlights] = my_shadow;
   my_shadow.id = num_shadowlights;
   num_shadowlights += 1;   
	wait(3);
	do_pointshadowmapping(my_shadow);
}

action my_spotlight() {
	wait(1);
	set(my,INVISIBLE);
	set(my,SPOTLIGHT);
	if(my.skill1) my.lightrange = clamp(my.skill1,5,20000);
	else my.lightrange = 500;
	if(my.skill2 || my.skill3 || my.skill4) { my.red = clamp(my.skill2,0,255); my.green = clamp(my.skill3,0,255); clamp(my.blue = my.skill4,0,255); }
	else { my.red = 255; my.green = 255; my.blue = 255; }
   SHADOW_STRUCT* my_shadow = malloc(sizeof(SHADOW_STRUCT));
   my_shadow.light = my;
   my_shadow.res = 0;
   if(my.skill5 == 128) my_shadow.res = 128; if(my.skill5 == 256) my_shadow.res = 256; if(my.skill5 == 512) my_shadow.res = 512; if(my.skill5 == 1024) my_shadow.res = 1024; if(my.skill5 == 2048) my_shadow.res = 2048;
   if(!my_shadow.res) my_shadow.res = 512;  
   my_shadow.range = my.lightrange;
   my_shadow.fade = 6000;
   if(my.skill6) my_shadow.arc = my.skill6;
   else my_shadow.arc = 45;
   my_shadow.soften = 150;
   my_shadow.depth_bias = 60;
   my_shadow.depth_blur = 40;
   my_shadow.blur = 50;
   my_shadow.brightness = 10;
   my_shadow.flags = SPOTLIGHT_SP | DEPTHBLUR | ACTIV;
   my_shadow.views = 1;
   my_shadow.change = 0; 
   shadowlights[num_shadowlights] = my_shadow; 
   my_shadow.id = num_shadowlights;
   num_shadowlights += 1;       
	wait(3);
	do_spotshadowmapping(my_shadow);
	var my_dir; my_dir = 1;
	while(1) {
		my.pan = my.pan+time_step*my_dir*2;
		if(my.pan > 90) my_dir = -1;
		if(my.pan < -90) my_dir = 1;
		//my.z = my.z+(key_8 - key_9)*time_step;
	   wait(1);
	}
}

//////////////////////////////////////////////control functions/////////////////////////////////////////////////////////////////

//function do_shadow_res() {  shadow_vars[0] = shadow_vars[0]+shadow_vars[0]; if(shadow_vars[0] > 2048) shadow_vars[0] = 256;  }
function restart_all() { short i;
 for(i=0;i<num_shadowlights;i++) {
	shadowlights[num_shadowlights].change = 1;
 } 
}
function exit_all() { short i;
 for(i=0;i<num_shadowlights;i++) {
 	reset(shadowlights[i],ACTIV);
	shadowlights[i].change = 1;
 } 
 wait(5);
 for(i=0;i<num_shadowlights;i++) {
    free(shadowlights[i]);
    shadowlights[i] = NULL;
 } 
 num_shadowlights = 0;
}
function create_pointlight(VECTOR* pos,range,COLOR* col) {
	you = ent_create(NULL,pos,my_pointlight);
	you.skill1 = range;
	you.skill2 = col.red;
	you.skill3 = col.green;
	you.skill4 = col.blue;
}

function create_spotlight(VECTOR* pos,range,COLOR* col,ANGLE* dir) {
	you = ent_create(NULL,pos,my_spotlight);
	you.skill1 = range;
	you.skill2 = col.red;
	you.skill3 = col.green;
	you.skill4 = col.blue;
	vec_set(you.pan,dir);
}